]> git.pld-linux.org Git - projects/rc-scripts.git/blame - rc.d/init.d/functions
register pld.sysinit-done to satisfy initctl check-config
[projects/rc-scripts.git] / rc.d / init.d / functions
CommitLineData
356d834b 1#!/bin/sh - keep it for file(1) to get bourne shell script result
7742e157 2# functions This file contains functions to be used by most or all
746a2130 3# shell scripts in the /etc/rc.d/init.d directory.
7742e157 4#
ec8b15cb 5# $Id$
7742e157
AF
6#
7# Author: Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
8a835e11 8# Hacked by: Greg Galloway and Marc Ewing
ffe19b59 9# Modified for PLD Linux by:
ec8b15cb 10# Marek Obuchowicz <elephant@pld-linux.org>
fdc764ae
ER
11# Arkadiusz Miśkiewicz <misiek@pld-linux.org>
12# Michał Kochanowicz <mkochano@pld-linux.org>
13# Łukasz Pawelczyk <havner@pld-linux.org>
7742e157
AF
14
15# First set up a default search path.
f2dd2d31 16export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
7742e157 17
d7e5835b 18# Set defaults
66f7cfac
ER
19if [ -z "$COLUMNS" -o -z "$LINES" ]; then
20 _setterm() {
21 set -- $(stty size 2>/dev/null)
22 LINES=${LINES:-$1}
23 COLUMNS=${COLUMNS:-$2}
24 }
25 _setterm
26 unset _setterm
27fi
ef72e56c
AM
28[ -z "$LINES" ] || [ "$LINES" -le 0 ] && LINES=40
29[ -z "$COLUMNS" ] || [ "$COLUMNS" -le 0 ] && COLUMNS=80
66f7cfac
ER
30export LINES COLUMNS
31INIT_COL=$((COLUMNS - 13))
9e9fac7d 32
503bfc80
AM
33# Set colors
34RED=1
35GREEN=2
36YELLOW=3
37BLUE=4
38MAGENTA=5
39CYAN=6
40WHITE=7
94b691da 41NORMAL=15
503bfc80
AM
42# Bold definition (second parameter to termput setaf)
43BOLD=1
44NOBOLD=0
45# Default colors
46CBRACKETS="$CYAN" # brackets [ ] color
47CDONE="$GREEN" # DONE and WORK color
48CBUSY="$MAGENTA" # BUSY color
49CFAIL="$RED" # FAIL and DIED color
50CPOWEREDBY="$CYAN" # "Powered by" color
51CPLD="$GREEN" # "PLD Linux Distribution" color
52CI="$RED" # Capital I color (press I to enter interactive startup)
53CRESMAN="$GREEN" # "Resource Manager" color
bca43764 54CHARS="" # Characters displayed on the beginning of show line
503bfc80
AM
55CCHARS="$NORMAL" # Color of these characters (look at /etc/sysconfig/init-colors.gentoo example)
56
31895ed1
ER
57# save from env, set by /sbin/service
58env_upstart=$USE_UPSTART
59
d7e5835b 60# Source configuration if available - may override default values
503bfc80 61[ -r /etc/sysconfig/init-colors ] && . /etc/sysconfig/init-colors
de1fc6ce 62[ -r /etc/sysconfig/system ] && . /etc/sysconfig/system
7f229d88 63[ -r /etc/sysconfig/bootsplash ] && . /etc/sysconfig/bootsplash
7e04fe0e 64
31895ed1
ER
65[ "$env_upstart" ] && USE_UPSTART=$env_upstart
66
9e22837c 67if [ -z "$VSERVER" -o "$VSERVER" = "detect" ]; then
ce397bd8
JR
68 {
69 while read _f _ctx; do
70 [ "$_f" = "VxID:" -o "$_f" = "s_context:" ] && break
71 done </proc/self/status
72 } 2>/dev/null
9e22837c
JR
73 if [ -z "$_ctx" -o "$_ctx" = "0" ]; then
74 VSERVER=no
75 else
76 VSERVER=yes
77 fi
55a4bc1b 78 unset _f _ctx
9e22837c
JR
79fi
80
2a7fa780
AM
81# VSERVER_ISOLATION_NET = isolation only inside of vserver guests
82if [ -z "$VSERVER_ISOLATION_NET" -o "$VSERVER_ISOLATION_NET" = "detect" ]; then
83 VSERVER_ISOLATION_NET=no
84 if [ "$VSERVER" = "yes" ]; then
46e27e96
ER
85 if [ -f /proc/self/nsproxy ]; then
86 {
87 while read _t _data; do
88 [ "$_t" = "net:" ] && break
89 done < /proc/self/nsproxy
90 } 2> /dev/null
91 else
92 # assume old kernel mode
93 VSERVER_ISOLATION_NET=yes
94 fi
2a7fa780
AM
95 if [ "${_data##*\(}" = "I)" ]; then
96 VSERVER_ISOLATION_NET=yes
97 fi
98 unset _f _data
99 fi
100fi
101
4132441e
ER
102# we need to know in functions if we were called from a terminal
103if [ -z "$ISATTY" ]; then
104 [ -t ] && ISATTY=yes || ISATTY=no
9cdf2de7 105 export ISATTY
4132441e
ER
106fi
107
18bd13ac 108is_yes() {
13a745bb 109 # Test syntax
ac1f65e1 110 if [ $# = 0 ]; then
13a745bb
AM
111 msg_usage " is_yes {value}"
112 return 2
113 fi
114
115 # Check value
116 case "$1" in
739070c4 117 yes|Yes|YES|true|True|TRUE|on|On|ON|Y|y|1)
13a745bb
AM
118 # true returns zero
119 return 0
120 ;;
739070c4 121 *)
13a745bb
AM
122 # false returns one
123 return 1
124 ;;
125 esac
126}
127
18bd13ac 128is_no() {
13a745bb 129 # Test syntax
ac1f65e1 130 if [ $# = 0 ]; then
13a745bb
AM
131 msg_usage " is_no {value}"
132 return 2
133 fi
134
135 case "$1" in
739070c4 136 no|No|NO|false|False|FALSE|off|Off|OFF|N|n|0)
13a745bb
AM
137 # true returns zero
138 return 0
139 ;;
739070c4 140 *)
13a745bb
AM
141 # false returns one
142 return 1
143 ;;
144 esac
145}
146
45e0ac73
ER
147# checks if file is empty
148# empty lines and lines beginning with hash are ignored
149is_empty_file() {
150 [ -s "$1" ] || return 0
a51d5138 151 grep -vqE "^(#|[[:blank:]]*$)" "$1" && return 1 || return 0
45e0ac73
ER
152}
153
1626fc86
ER
154# returns OK if $1 contains $2
155strstr() {
4ec13019
ER
156 local a=$2
157 [ "${1#*$a*}" = "$1" ] && return 1
1626fc86
ER
158 return 0
159}
160
bc94aa53 161if is_yes "$FASTRC" || is_yes "$IN_SHUTDOWN"; then
d84e0c78
JR
162 RC_LOGGING=no
163fi
164
bc94aa53 165if is_no "$RC_LOGGING"; then
18bd13ac 166 initlog() {
6d0838f4 167 RESULT=0
bb49a1c7 168 while [ "$1" != "${1##-}" ]; do
0a35929a 169 case $1 in
739070c4 170 -c)
5e6dfc29
JR
171 shift
172 $1
173 RESULT=$?
174 break
175 ;;
739070c4 176 *)
5e6dfc29
JR
177 shift
178 ;;
0a35929a
AM
179 esac
180 done
6d0838f4 181 return $RESULT
0a35929a
AM
182 }
183fi
184
18bd13ac 185kernelver() {
e9e5c299 186 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
187 {
188 read _x _y v _z
189 old_IFS=$IFS
e9e5c299
JR
190 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
191 IFS='_-'
55a4bc1b 192 set -- $v
e9e5c299
JR
193 v1=${1}
194 IFS='.'
195 set -- $v1
55a4bc1b 196 IFS=$old_IFS
28d62f54 197
e9e5c299 198 ver=${3}
28d62f54 199 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 200 ver="$2$ver"
28d62f54 201 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b 202 ver="$1$ver"
28d62f54 203 while [ ${#ver} -lt 9 ]; do ver="0$ver"; done
55a4bc1b 204 echo $ver
28d62f54 205 } < /proc/version
6f2d09b1
AM
206}
207
18bd13ac 208kernelverser() {
480529b0 209 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
210 {
211 read _x _y v _z
212 old_IFS=$IFS
e9e5c299
JR
213 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
214 IFS='_-'
55a4bc1b 215 set -- $v
e9e5c299
JR
216 v1=${1}
217 IFS='.'
218 set -- $v1
55a4bc1b
JR
219 IFS=$old_IFS
220 ver=$2
ac1f65e1 221 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 222 ver="$1$ver"
ac1f65e1 223 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b
JR
224 echo $ver
225 } </proc/version
6f2d09b1
AM
226}
227
18bd13ac 228kernelvermser() {
480529b0 229 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
230 {
231 read _x _y v _z
232 old_IFS=$IFS
e9e5c299
JR
233 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
234 IFS='_-'
55a4bc1b 235 set -- $v
e9e5c299
JR
236 v1=${1}
237 IFS='.'
238 set -- $v1
55a4bc1b 239 IFS=$old_IFS
e9e5c299 240 ver="$1"
ac1f65e1 241 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b
JR
242 echo $ver
243 } </proc/version
6f2d09b1
AM
244}
245
cee18a41 246# Colors workaround
18bd13ac 247termput() {
4132441e 248 is_yes "$ISATTY" || return
e3aafb2f 249
294b03eb 250 if is_yes "$FASTRC" || is_no "$TPUT"; then
972964bb 251 case "$1" in
739070c4 252 hpa)
8a835e11 253 echo -ne "\033[$(($2+1))G"
972964bb 254 ;;
739070c4 255 cuu*)
8a835e11 256 echo -ne "\033[${2}A"
972964bb 257 ;;
739070c4 258 el)
8a835e11 259 echo -ne "\033[0K"
972964bb 260 ;;
739070c4 261 setaf)
944d6d80 262 local ISBOLD
503bfc80
AM
263 if [ -n "$3" ]; then
264 ISBOLD="$3"
265 else
266 ISBOLD="$NOBOLD";
267 fi
268 is_yes "$COLOR_INIT" && echo -ne "\033[${ISBOLD};3${2}m"
8a835e11 269 ;;
739070c4 270 op)
503bfc80 271 termput setaf $NORMAL
dcb00bd9 272 ;;
8a835e11 273 esac
c6c1bd0c 274 else
8a835e11 275 case "$1" in
739070c4 276 hpa | cuu* | el)
8a835e11 277 tput "$@"
945790a2 278 ;;
739070c4 279 setaf)
ac1f65e1 280 if [ "$3" = "1" ]; then tput bold; else tput sgr0; fi
503bfc80 281 is_yes "$COLOR_INIT" && tput setaf "$2"
945790a2 282 ;;
739070c4 283 op)
503bfc80 284 termput setaf $NORMAL
945790a2 285 ;;
8a835e11 286 esac
c6c1bd0c
AF
287 fi
288}
cee18a41 289
0c4f3cf5
ER
290if [ ! -x /bin/printf ]; then
291 # printf equivalent
292 # FIXME: buggy when single or double quotes in message!
18bd13ac 293 printf() {
944d6d80 294 local text m
0c4f3cf5
ER
295 text="$1"
296 shift
297 if [ $# -gt 0 ]; then
298 m="$1"
299 shift
300 while [ $# -gt 0 ]; do
301 m="$m\",\"$1"
302 shift
303 done
304 fi
305 awk "BEGIN {printf \"$text\", \"$m\"; }"
306 }
307fi
8a835e11 308
38198f50 309# National language support function
18bd13ac 310nls() {
944d6d80 311 local msg_echo nls_domain text message
d553f606 312 msg_echo='\n'
50ed8c3f 313 nls_domain="$NLS_DOMAIN"
e2c2c3a6 314 while [ "$1" != "${1##-}" ]; do
d553f606 315 case "$1" in
739070c4 316 --nls-domain)
8a835e11 317 shift
50ed8c3f 318 nls_domain="$1"
8a835e11 319 shift
320 ;;
739070c4 321 -n)
8a835e11 322 msg_echo=''
323 shift
324 ;;
d553f606
JR
325 esac
326 done
327 message="$1"
328 shift
50ed8c3f 329
d553f606
JR
330 # empty message, so we return --misiek
331 if [ -z "$message" ]; then
d553f606
JR
332 echo -en "$msg_echo"
333 return
38198f50 334 fi
8a835e11 335
e2c2c3a6
ER
336 if is_yes "$GETTEXT"; then
337 message=$(TEXTDOMAINDIR="/etc/sysconfig/locale" gettext -e --domain="${nls_domain:-rc-scripts}" "$message")
972964bb 338 fi
8a835e11 339
e2c2c3a6 340 printf "$message" "$@"
d553f606 341 echo -en "$msg_echo"
38198f50
AM
342}
343
18bd13ac 344rc_splash() {
944d6d80 345 local action="$1"
862c980c 346
9e22837c 347 if ! is_no "$BOOT_SPLASH" && ! is_yes "$VSERVER"; then
fae22957
AM
348 [ -x /bin/splash ] && /bin/splash "$action"
349 fi
b6509675
AM
350
351 : $((progress++))
fae22957
AM
352}
353
18bd13ac 354msg_network_down() {
228edf1d 355 nls "ERROR: Networking is down. %s can't be run." "$1" >&2
a916d1c6 356}
357
18bd13ac 358msg_starting() {
a916d1c6 359 show "Starting %s service" "$1"
360}
361
18bd13ac 362msg_already_running() {
599d198a 363 nls "%s service is already running." "$1"
a916d1c6 364}
365
18bd13ac 366msg_stopping() {
a916d1c6 367 show "Stopping %s service" "$1"
368}
369
18bd13ac 370msg_not_running() {
599d198a 371 nls "%s service is not running." "$1"
a916d1c6 372}
373
18bd13ac 374msg_reloading() {
a916d1c6 375 show "Reloading %s service" "$1"
376}
377
18bd13ac 378msg_usage() {
599d198a 379 nls "Usage: %s" "$*"
a916d1c6 380}
381
ffe19b59 382# Some functions to handle PLD Linux-style messages
18bd13ac 383show() {
944d6d80 384 local text len
0a35929a 385
ce410bbc
JR
386 if is_no "$FASTRC" && is_yes "$GETTEXT"; then
387 text=$(nls -n "$@")
388 else
389 text=$(printf "$@")
390 fi
391 len=${#text}
392 while [ $((len++)) -lt $INIT_COL ]; do
393 text="$text."
394 done
395 if [ -n "$CHARS" ]; then
396 termput setaf $CCHARS
397 echo -n "$CHARS"
398 termput op
399 fi
400 echo -n "$text"
7742e157
AF
401}
402
18bd13ac 403deltext() {
a292b175
ER
404 termput hpa $INIT_COL
405}
406
b9cad282 407# Displays message in square brackests ("[ DONE ]"). Takes two arguments.
408# First is the text to display, second is color number to use (argument to
409# tput setaf). If second argument is not given, default (2, green) will be
410# used).
18bd13ac 411progress() {
944d6d80
ER
412 local COLOR
413 if [ -n "$2" ]; then
414 COLOR="$2"
415 else
416 COLOR="$CDONE"
417 fi
cd8dfdf0 418 deltext
503bfc80 419 echo -n "$(termput setaf $CBRACKETS)[$(termput setaf $COLOR) $(nls --nls-domain rc-scripts "$1") $(termput setaf $CBRACKETS)]$(termput op)"
b9cad282 420}
421
18bd13ac 422busy() {
a292b175 423 echo -n "$_busy"
7742e157
AF
424}
425
18bd13ac 426ok() {
a292b175 427 echo "$_ok"
7742e157
AF
428}
429
18bd13ac 430started() {
a292b175 431 echo "$_started"
7e04fe0e 432}
433
18bd13ac 434fail() {
a292b175 435 echo "$_fail"
d553f606 436 return 1
7742e157
AF
437}
438
18bd13ac 439died() {
a292b175 440 echo "$_died"
d553f606 441 return 1
6cac3cb2 442}
443
bbb612de 444# Check if $pid (could be plural) are running
18bd13ac 445checkpid() {
8a835e11 446 while [ "$1" ]; do
447 [ -d "/proc/$1" ] && return 0
448 shift
449 done
450 return 1
bbb612de
AM
451}
452
290eb891
AM
453# - outside chroot get only those processes, which are outside chroot.
454# - inside chroot get only those processes, which are inside chroot.
455# - don't filter out pids which do not have corresponding running processes (process died etc)
1e5e8177 456# (note: some processes like named are chrooted but run outside chroot)
c3403882 457# - do nothing inside vserver
18bd13ac 458filter_chroot() {
c3403882
JR
459 if is_yes "$VSERVER"; then
460 echo $@
461 return
462 fi
ac1f65e1 463 if [ $# -lt 1 -o ! -d /proc/1 ]; then
8e3b6875
AM
464 echo $@
465 return
466 fi
33ca787f 467 local root_dir good_pids="" good_add_pid
1e5e8177
AM
468 for root_pid in $@; do
469 root_dir=$(resolvesymlink /proc/${root_pid}/root)
470 if [ -n "$root_dir" ]; then
5a8ff397
AM
471 good_add_pid=1
472 if [ -n "${SYSTEM_CHROOTS}" ]; then
473 for r_dir in ${SYSTEM_CHROOTS}; do
474 echo "$root_dir" | grep -q "^${r_dir}" && good_add_pid=0
475 done
476 fi
477 [ "$good_add_pid" -eq 1 ] && good_pids="$good_pids $root_pid"
290eb891
AM
478 elif [ ! -d "/proc/$root_pid" ]; then
479 good_pids="$good_pids $root_pid"
1e5e8177 480 fi
5a8ff397
AM
481 done
482 echo $good_pids
1e5e8177
AM
483}
484
3e224b2a
ER
485# Usage:
486# run_cmd Message command_to_run
487# run_cmd -a Message command_to_run
488# run_cmd --user "username" "Message" command_to_run
18bd13ac 489run_cmd() {
3e224b2a
ER
490 local force_err=0 exit_code=0 errors user
491 while [ $# -gt 0 ]; do
492 case "$1" in
493 -a)
494 force_err=1
495 ;;
496 --user)
497 shift
498 user=$1
499 ;;
500 *)
501 break
502 esac
8a835e11 503 shift
3e224b2a
ER
504 done
505
506 local message=$1; shift
d553f606 507 show "$message"; busy
3e224b2a 508
f10f2102 509 if errors=$(
3e224b2a 510 cd /
f10f2102
ER
511 export HOME=/tmp TMPDIR=/tmp
512 if is_no "$RC_LOGGING"; then
3e224b2a 513 ${user:+setuidgid -s $user} "$@" 2>&1
f10f2102 514 else
3e224b2a 515 ${user:+setuidgid -s $user} initlog -c "$*" 2>&1
f10f2102
ER
516 fi
517 ); then
cd8dfdf0 518 ok
d553f606 519 log_success "$1 $message"
1b228409 520 else
d553f606
JR
521 fail
522 log_failed "$1 $message"
b7299ffc 523 exit_code=1
1b228409 524 fi
d553f606 525 [ -n "$errors" ] && [ $exit_code -eq 1 -o $force_err -eq 1 ] && echo "$errors"
1b228409 526 return $exit_code
cee18a41
AM
527}
528
e81194ca 529_daemon_set_ulimits() {
0fba6fe4
ER
530 local opt val ksh=${KSH_VERSION:+1}
531 set -- ${SERVICE_LIMITS:-$DEFAULT_SERVICE_LIMITS}
532 while [ $# -gt 0 ]; do
533 opt=$1
534 val=$2
535 if [ "$ksh" ]; then
536 case "$opt" in
537 -Hu)
538 opt=-Hp
539 ;;
540 -Su)
541 opt=-Sp
542 ;;
543 -u)
544 opt=-p
545 ;;
546 esac
547 fi
548 ulimit $opt $val
549 shift 2
550 done
e81194ca
ER
551}
552
e2e24f5a 553# A function to start a program (now it's useful on read-only filesystem too)
18bd13ac 554daemon() {
944d6d80
ER
555 local errors="" prog="" end="" waitname="" waittime=""
556 local exit_code=0
42595a81 557 local nice=$SERVICE_RUN_NICE_LEVEL
64c571c5 558 local fork user closefds redirfds pidfile makepid chdir=/
42595a81 559
210ff16f
ER
560 # NOTE: if you wonder how the shellish (by syntax) $prog works in ssd mode,
561 # then the answer is: it totally ignores $prog and uses "$@" itself.
562
42595a81 563 while [ $# -gt 0 ]; do
d553f606 564 case $1 in
739070c4 565 '')
64c571c5 566 msg_usage " daemon [--check] [--user user] [--fork] [--chdir directory] [--closefds] [--redirfds] [--waitforname procname] [--waitfortime seconds] [--pidfile file] [--makepid] [+/-nicelevel] {program} <program args>"
8a835e11 567 return 2
d553f606 568 ;;
739070c4 569 --check)
d553f606
JR
570 # for compatibility with redhat/mandrake
571 nls "warning: --check option is ignored!"
572 shift
d553f606 573 ;;
739070c4 574 --user)
d553f606 575 shift
7b1a2a70 576 [ "$1" != "root" ] && prog="/bin/su $1 -s /bin/sh -c \""
f10f2102 577 user=$1
d553f606 578 ;;
739070c4
ER
579 --fork)
580 fork=1
b486c392
ER
581 prog="/usr/bin/setsid sh -c \""
582 end='&'
b486c392 583 ;;
6b1fd029
ER
584 --chdir)
585 shift
586 chdir=$1
587 ;;
739070c4
ER
588 --closefds)
589 closefds=1
f10f2102 590 ;;
64c571c5
ER
591 --redirfds)
592 redirfds=1
593 ;;
739070c4 594 --waitforname)
b486c392 595 shift
683d384e 596 waitname="$1"
683d384e 597 ;;
739070c4 598 --waitfortime)
b486c392 599 shift
683d384e 600 waittime="$1"
683d384e 601 ;;
739070c4 602 --pidfile)
0a177614
ER
603 shift
604 pidfile="$1"
5bf237b7 605 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
0a177614 606 ;;
a160c01b
PG
607 --makepid)
608 makepid=1
609 ;;
739070c4 610 -*|+*)
42595a81 611 nice=$1
a6e727aa 612 shift
42595a81
ER
613 break
614 ;;
739070c4 615 *)
42595a81 616 break
683d384e 617 ;;
d553f606 618 esac
42595a81 619 shift
d553f606 620 done
2eea8492 621 # If command to execute ends with quotation mark, add remaining
622 # arguments and close quotation.
623 if [ "$prog" != "${prog%\"}" ]; then
565736ed 624 prog="$prog $*$end\""
2eea8492 625 else
565736ed 626 prog="$prog $*$end"
2eea8492 627 fi
7742e157 628
e81194ca 629 _daemon_set_ulimits
f054a85e 630
3edf5e48 631 [ -z "$DEFAULT_SERVICE_UMASK" ] && DEFAULT_SERVICE_UMASK=022
42595a81 632 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
3edf5e48 633
7742e157
AF
634 # And start it up.
635 busy
6b1fd029 636 cd $chdir
42595a81 637 [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" && echo $$ > "/dev/cpuset/${SERVICE_CPUSET}/tasks"
18bd13ac 638 if errors=$(
f10f2102 639 umask ${SERVICE_UMASK:-$DEFAULT_SERVICE_UMASK};
739070c4 640 export USER=root HOME=/tmp TMPDIR=/tmp
f10f2102
ER
641 nice=${nice:-$DEFAULT_SERVICE_RUN_NICE_LEVEL}
642 nice=${nice:-0}
643
644 if [ "$closefds" = 1 ]; then
645 exec 1>&-
646 exec 2>&-
647 exec 0>&-
64c571c5
ER
648 elif [ "$redirfds" = 1 ]; then
649 exec 1>/dev/null
650 exec 2>/dev/null
651 exec 0>/dev/null
f10f2102
ER
652 else
653 exec 2>&1
654 fi
655
ac1f65e1 656 if is_no "$RC_LOGGING"; then
f10f2102
ER
657 prog=$1; shift
658 if [ ! -x $prog ]; then
659 logger -t rc-scripts -p daemon.debug "daemon: Searching PATH for $prog, consider using full path in initscript"
660 local a o=$IFS
661 IFS=:
662 for a in $PATH; do
663 if [ -x $a/$prog ]; then
664 prog=$a/$prog
665 break
666 fi
667 done
668 IFS=$o
669 fi
670 /sbin/start-stop-daemon -q --start \
671 --nicelevel $nice \
672 ${pidfile:+--pidfile $pidfile} \
86ed0b8f 673 ${makepid:+--make-pidfile} \
8a5b611f 674 ${user:+--chuid $user} \
6b1fd029 675 ${chdir:+--chdir "$chdir"} \
86ed0b8f
TP
676 ${fork:+--background} \
677 ${waitname:+--name $waitname} \
69bdc5ba 678 ${SERVICE_DROPCAPS:+--dropcap $SERVICE_DROPCAPS} \
f10f2102
ER
679 --exec "$prog" \
680 -- ${1:+"$@"}
681 else
682 nice -n $nice initlog -c "$prog" 2>&1
683 fi
18bd13ac 684 ); then
f10f2102 685
683d384e
AM
686 if [ -n "$waitname" -a -n "$waittime" ]; then
687 # Save basename.
03e01a49 688 base=${waitname##*/}
683d384e
AM
689 # Find pid.
690 pid=$(pidofproc "$waitname" "$pidfile")
691 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
692 i=0
693 while [ "$i" -lt "$waittime" ]; do
42595a81 694 i=$((i + 1))
683d384e
AM
695 checkpid $pid && sleep 1 || break
696 done
697 fi
d553f606 698 log_success "$1 startup"
1b228409 699 ok
7742e157 700 else
b7299ffc 701 exit_code=1
1b228409 702 fail
d553f606 703 log_failed "$1 startup"
4fbe82fd 704 [ -n "$errors" ] && echo >&2 "$errors"
7742e157 705 fi
b7299ffc 706 return $exit_code
7742e157
AF
707}
708
709# A function to stop a program.
18bd13ac 710killproc() {
944d6d80 711 local notset killlevel base pid pidfile result
7742e157
AF
712 # Test syntax.
713 if [ $# = 0 ]; then
3fa0b8fe 714 msg_usage " killproc [--pidfile PIDFILE] {program} [-SIGNAME]"
228edf1d 715 return 2
7742e157
AF
716 fi
717
bb49a1c7 718 while [ "$1" != "${1##-}" ]; do
8de7f381 719 case $1 in
a5363bea 720 --pidfile|-p)
53ae90e8 721 pidfile="$2"
5bf237b7 722 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
53ae90e8 723 shift 2
8de7f381 724 ;;
739070c4 725 --waitforname)
53ae90e8
ER
726 waitname="$2"
727 shift 2
683d384e 728 ;;
739070c4 729 --waitfortime)
53ae90e8
ER
730 waittime="$2"
731 shift 2
683d384e 732 ;;
8de7f381
AM
733 esac
734 done
735
7742e157 736 busy
8a835e11 737
944d6d80 738 local notset=0
7742e157 739 # check for second arg to be kill level
ac1f65e1 740 if [ -n "$2" ]; then
7742e157
AF
741 killlevel=$2
742 else
743 notset=1
7742e157
AF
744 fi
745
2f269bdf
ER
746 # experimental start-stop-daemon based killing.
747 # works only with pidfile
748 if is_no "$RC_LOGGING" && [ "$pidfile" ]; then
5ec58ec2 749 local sig=${killlevel:--TERM}
2e00b711 750 /sbin/start-stop-daemon -q --stop \
2f269bdf
ER
751 --retry ${sig#-}/10/${sig#-}/60/KILL/10 \
752 -s ${sig#-} \
753 ${pidfile:+--pidfile $pidfile}
754 result=$?
755 if [ "$result" -eq 0 ]; then
756 ok
757 else
758 fail
759 fi
760 return $result
761 fi
762
763
228edf1d 764 # Save basename.
03e01a49 765 base=${1##*/}
7742e157 766
228edf1d 767 # Find pid.
8de7f381
AM
768 pid=$(pidofproc "$1" "$pidfile")
769 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
7742e157 770
228edf1d 771 # Kill it.
ac1f65e1
TP
772 if [ -n "$pid" -a "$pid" != "$$" ] && checkpid $pid 2>&1; then
773 if [ "$notset" = "1" ]; then
228edf1d 774 if checkpid $pid 2>&1; then
775 # TERM first, then KILL if not dead
776 kill -TERM $pid
777 usleep 100000
778 if checkpid $pid && sleep 1 &&
779 checkpid $pid && sleep 3 &&
780 checkpid $pid; then
53ae90e8
ER
781 # XXX: SIGKILL is sent already on 4th second!
782 # HARMFUL for example to mysqld (which is already workarounded)
228edf1d 783 kill -KILL $pid
784 usleep 100000
785 fi
7742e157 786 fi
228edf1d 787 checkpid $pid
bbb612de
AM
788 result=$?
789 if [ "$result" -eq 0 ]; then
228edf1d 790 fail
791 log_failed "$1 shutdown"
792 else
793 ok
794 log_success "$1 shutdown"
795 fi
796 result=$(( ! $result ))
797 else
798 # use specified level only
799 if checkpid $pid > /dev/null 2>&1; then
800 kill $killlevel $pid
801 result=$?
802 if [ "$result" -eq 0 ]; then
803 ok
804 log_success "$1 got $killlevel"
805 else
806 result=7
807 fail
808 log_failed "$1 didn't get $killlevel"
809 fi
e016cdae 810 else
228edf1d 811 result=7
812 died
813 log_failed "$1 shutdown"
e016cdae 814 fi
7742e157
AF
815 fi
816 else
228edf1d 817 died
818 log_failed "$1 shutdown"
819 result=7
7742e157 820 fi
5e6dfc29 821
683d384e 822 if [ -n "$waitname" -a -n "$waittime" ]; then
e6f93a80 823 # Save basename.
03e01a49 824 base=${waitname##*/}
e6f93a80
AM
825 # Find pid.
826 pid=$(pidofproc "$waitname" "$pidfile")
827 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
683d384e
AM
828 i=0
829 while [ "$i" -lt "$waittime" ]; do
1101d321 830 i=$(( i + 1 ))
683d384e
AM
831 checkpid $pid && sleep 1 || break
832 done
833 fi
7742e157 834
228edf1d 835 # Remove pid file if any.
e016cdae 836 if [ "$notset" = "1" ]; then
228edf1d 837 rm -f /var/run/${base}.pid
7742e157 838 fi
bbb612de
AM
839
840 return $result
7742e157
AF
841}
842
843# A function to find the pid of a program.
18bd13ac 844pidofproc() {
944d6d80 845 local pid pidfile base=${1##*/}
8de7f381
AM
846 pidfile="$base.pid"
847 [ -n "$2" ] && pidfile="$2"
7742e157 848
8a835e11 849 # Test syntax.
ac1f65e1 850 if [ $# = 0 ]; then
8a835e11 851 msg_usage " pidofproc {program}"
852 return 2
853 fi
854
8de7f381 855 # First try pidfile or "/var/run/*.pid"
5bf237b7
ER
856 case "$pidfile" in
857 /*)pidfile="${pidfile}";;
858 *) pidfile="/var/run/$pidfile";;
859 esac
ac1f65e1 860 if [ -f "${pidfile}" ]; then
944d6d80 861 local p pid=""
7eb94de6 862 for p in $(< "${pidfile}"); do
3030e60e 863 [ -z "$(echo "$p" | awk '{gsub(/[0-9]/,"");print;}')" ] && pid="$pid $p"
8a835e11 864 done
7742e157 865 fi
8a835e11 866
7742e157 867 # Next try "pidof"
1e5e8177
AM
868 [ -z "$pid" ] && pidof -o $$ -o $PPID -o %PPID -x "$1"
869 pid=$(filter_chroot "$pid")
870 echo $pid
7742e157 871}
12de71be 872
1b59b41b 873# status [--pidfile PIDFILE] {subsys} [{daemon}]"
18bd13ac 874status() {
944d6d80 875 local pid subsys daemon cpuset_msg pidfile
3232ec7b 876 if [ "$1" = "--pidfile" -o "$1" = "-p" ]; then
4e901aa0 877 pidfile=$2
5bf237b7 878 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
4e901aa0
ER
879 shift 2
880 fi
881
8a835e11 882 subsys=$1
883 daemon=${2:-$subsys}
bbb612de 884
8a835e11 885 # Test syntax.
ac1f65e1 886 if [ $# = 0 ]; then
4e901aa0 887 msg_usage " status [--pidfile PIDFILE] {subsys} [{daemon}]"
8a835e11 888 return 2
889 fi
bbb612de 890
4e901aa0 891 # if pidfile specified, pid must be there
24ab860c
ER
892 if [ "$pidfile" ]; then
893 [ -f "$pidfile" ] && read pid < $pidfile
305c3281
ER
894 # filter_chroot does not filter out dead pids, so this extra check, see t/status-pidfile.sh
895 if [ ! -d "/proc/$pid" ]; then
896 pid=
897 fi
4e901aa0
ER
898 else
899 pid=$(pidof -o $$ -o $PPID -o %PPID -x $daemon)
900 fi
1e5e8177 901 pid=$(filter_chroot "$pid")
bbb612de 902
b90fbc1e 903 if [ "$pid" ]; then
814e38ce 904 cpuset_msg="..."
c51af89c
ER
905 if [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS"; then
906 if grep -q "$pid" "/dev/cpuset/${SERVICE_CPUSET}/tasks"; then
814e38ce
JR
907 cpuset_msg=$(nls " in cpuset %s..." "$SERVICE_CPUSET")
908 else
909 cpuset_msg=$(nls " outside of configured cpuset %s..." "$SERVICE_CPUSET")
910 fi
911 fi
912 nls "%s (pid %s) is running%s" "$daemon" "$pid" "$cpuset_msg"
8a835e11 913 return 0
8a835e11 914 fi
915
1b59b41b 916 # Next try "/var/run/*.pid" files; if pidfile is not set
4e901aa0 917 local base=${daemon##*/}
1b59b41b 918 if [ -z "$pidfile" -a -f /var/run/${base}.pid ]; then
8a835e11 919 read pid < /var/run/${base}.pid
1e5e8177 920 pid=$(filter_chroot "$pid")
1b59b41b
ER
921 if [ "$pid" ]; then
922 nls "%s dead but pid file (%s) exists" "$subsys" /var/run/${base}.pid
8a835e11 923 return 1
924 fi
925 fi
926
927 # See if /var/lock/subsys/$subsys exists
928 if [ -f /var/lock/subsys/$subsys ]; then
1b59b41b 929 nls "daemon %s dead but subsys (%s) locked" "$daemon" "$subsys"
8a835e11 930 return 2
7742e157 931 fi
8a835e11 932 nls "%s is stopped" "$subsys"
933 return 3
7742e157 934}
0524c81f 935
6b4a354c
AM
936# Confirm whether we really want to run this service
937confirm() {
944d6d80 938 local answer
d553f606 939 nls -n "Start service %s (Y)es/(N)o/(C)ontinue? [Y] " "$1"
6b4a354c
AM
940 read answer
941 case $answer in
739070c4 942 y|Y|t|T|j|J|"")
8a835e11 943 return 0
6b4a354c 944 ;;
739070c4 945 c|C|k|K|w|W)
8a835e11 946 return 2
6b4a354c 947 ;;
739070c4 948 n|N)
8a835e11 949 return 1
6b4a354c 950 ;;
739070c4 951 *)
8a835e11 952 confirm $1
953 return $?
6b4a354c
AM
954 ;;
955 esac
956}
957
d553f606 958# module is needed (ie. is requested, is available and isn't loaded already)
18bd13ac 959is_module() {
d553f606 960 # module name without .o at end
5778a670 961 if ! lsmod | grep -q "$1"; then
63d30ecf 962 if ls -1R /lib/modules/$(uname -r)/ 2> /dev/null | grep -q "^${1}.\(\|k\)o\(\|.gz\)"; then
d553f606
JR
963 # true
964 return 0
965 fi
966 fi
967 # false
968 return 1
0524c81f 969}
f7b2d235 970
18bd13ac 971_modprobe() {
944d6d80 972 local parsed single die args foo result
f7b2d235 973 parsed=no
ac1f65e1 974 while is_no "$parsed"; do
f7b2d235 975 case "$1" in
739070c4 976 "single")
8a835e11 977 single=yes
978 shift
979 ;;
739070c4 980 "die")
8a835e11 981 die=yes
982 shift
983 ;;
739070c4 984 -*)
8a835e11 985 args="$args $1"
986 shift
987 ;;
739070c4 988 *)
8a835e11 989 parsed=yes
990 ;;
f7b2d235
JR
991 esac
992 done
ac1f65e1 993 if is_yes "${single}"; then
f7b2d235
JR
994 foo="$@"
995 show "Loading %s kernel module(s)" "$foo"
f7b2d235
JR
996 busy
997 fi
ac1f65e1 998 if [ -x /sbin/modprobe ]; then
f7b2d235
JR
999 /sbin/modprobe -s $args "$@"
1000 result=$?
1001 else
ac1f65e1 1002 deltext; fail
f7b2d235
JR
1003 result=1
1004 fi
ac1f65e1 1005 if is_yes "${single}"; then
f7b2d235 1006 deltext
ac1f65e1 1007 if [ $result = "0" ]; then
d553f606 1008 is_yes "$single" && ok
f7b2d235
JR
1009 else
1010 fail
ac1f65e1 1011 if is_yes "$die"; then
f7b2d235
JR
1012 nls "Could not load %s kernel module(s)" "$@"
1013 exit 1
1014 fi
1015 fi
1016 fi
f7b2d235 1017}
d553f606 1018
bc94aa53
ER
1019if is_no "$RC_LOGGING"; then
1020 log_success() {
1021 :
1022 }
d553f606 1023
18bd13ac 1024 log_failed() {
bc94aa53
ER
1025 :
1026 }
1027else
18bd13ac 1028 log_success() {
bc94aa53
ER
1029 initlog -n $0 -s "$1 $2" -e 1
1030 }
1031
18bd13ac 1032 log_failed() {
bc94aa53
ER
1033 initlog -n $0 -s "$1 $2" -e 2
1034 }
1035fi
d553f606 1036
f0c296a0
JR
1037# Check if any flavor of portmapper is running
1038check_portmapper() {
cbb91a00
ER
1039 if [ -x /usr/sbin/rpcinfo ]; then
1040 if /usr/sbin/rpcinfo -p localhost >/dev/null 2>/dev/null; then
fd8737b5 1041 return 0
f0c296a0
JR
1042 else
1043 return 1
1044 fi
5bf237b7
ER
1045 elif [ -z "$(pidof portmap)" -a -z "$(pidof rpcbind)" ]; then
1046 return 1
f0c296a0
JR
1047 fi
1048 return 0
1049}
1050
fab8c1a1
JR
1051# is_fsmounted fstype mntpoint
1052# Check if filesystem fstype is mounted on mntpoint
1053is_fsmounted() {
944d6d80
ER
1054 local fstype=$1
1055 local mntpoint=$2
fab8c1a1
JR
1056
1057 [ -n "$fstype" -a -n "$mntpoint" ] || return 1
1058
81ebaa15 1059 if [ -r /proc/mounts ]; then
bfd0227f 1060 grep -qE "[[:blank:]]$mntpoint[[:blank:]]+$fstype[[:blank:]]" /proc/mounts
81ebaa15 1061 return $?
fab8c1a1 1062 else
5bf237b7 1063 if [ "$(stat -L -f -c %T $mntpoint 2>/dev/null)" = "$fstype" ]; then
81ebaa15
JR
1064 return 0
1065 else
1066 return 1
1067 fi
fab8c1a1
JR
1068 fi
1069}
1070
83b3ef3b
AM
1071# __umount_loop awk_program fstab_file first_msg retry_msg umount_args
1072# awk_program should process fstab_file and return a list of fstab-encoded
1073# paths; it doesn't have to handle comments in fstab_file.
1074__umount_loop() {
1075 local remaining sig=
1076 local retry=3 count
1077
1078 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1079 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1080 if [ "$retry" -eq 3 ]; then
1081 run_cmd "$3" fstab-decode umount $5 $remaining
1082 else
1083 run_cmd "$4" fstab-decode umount $5 $remaining
1084 fi
1085 count=4
1086 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1087 while [ "$count" -gt 0 ]; do
1088 [ -z "$remaining" ] && break
1089 count=$(($count-1))
1090 usleep 500000
1091 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1092 done
1093 [ -z "$remaining" ] && break
a1170350 1094 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1095 sleep 3
1096 retry=$(($retry -1))
1097 sig=-9
1098 done
1099}
1100
1101# Similar to __umount loop above, specialized for loopback devices
1102__umount_loopback_loop() {
1103 local remaining devremaining sig=
1104 local retry=3
1105
1106 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1107 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1108 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1109 if [ "$retry" -eq 3 ]; then
1110 run_cmd "Unmounting loopback filesystems: " \
1111 fstab-decode umount $remaining
1112 else
1113 run_cmd "Unmounting loopback filesystems (retry):" \
1114 fstab-decode umount $remaining
1115 fi
1116 for dev in $devremaining ; do
1117 losetup $dev > /dev/null 2>&1 && \
1118 run_cmd "Detaching loopback device $dev: " \
1119 losetup -d $dev
1120 done
1121 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1122 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1123 [ -z "$remaining" ] && break
a1170350 1124 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1125 sleep 3
1126 retry=$(($retry -1))
1127 sig=-9
1128 done
1129}
1130
0084dcf3 1131rc_cache_init() {
6e311c54
ER
1132 # If we have cachefile, use it.
1133 # If we don't, create memory variables and try to save silently,
acf05b4f 1134 local cachefile='/var/cache/rc-scripts/msg.cache'
0084dcf3 1135
4132441e
ER
1136 local term
1137 if is_yes "$ISATTY"; then
1138 term=$TERM
1139 else
1140 term=dumb
1141 fi
1142
0084dcf3
ER
1143 # We create $check variable which is used to invalidate the cache.
1144 # The $check contains user locale and terminal.
66f7cfac 1145 local check="$term.$LC_MESSAGES.$INIT_COL"
0084dcf3 1146
f9df72e7 1147 if [ -f "$cachefile" -a "$cachefile" -nt /etc/sysconfig/system -a "$cachefile" -nt /etc/sysconfig/init-colors ]; then
0084dcf3
ER
1148 if . "$cachefile" 2>/dev/null; then
1149 if [ "$check" = "$_check" ]; then
1150 return
1151 fi
1152 fi
f9df72e7
ER
1153 fi
1154
1155 # primitive caching
1156 _busy=$(progress "BUSY" "$CBUSY")
1157 _ok=$(progress "DONE")
1158 _started=$(progress "WORK")
1159 _fail=$(progress "FAIL" "$CFAIL")
1160 _died=$(progress "DIED" "$CFAIL")
cc54351b
ER
1161
1162 # we don't use heredoc, as ksh attempts to create tempfile then
3ba0bc12 1163 (> "$cachefile" ) 2>/dev/null || return
cc54351b
ER
1164 echo "_busy='$_busy';" >> "$cachefile"
1165 echo "_ok='$_ok';" >> "$cachefile"
1166 echo "_started='$_started';" >> "$cachefile"
1167 echo "_fail='$_fail';" >> "$cachefile"
1168 echo "_died='$_died';" >> "$cachefile"
1169 echo "_check='$check';" >> "$cachefile"
f9df72e7
ER
1170}
1171
0084dcf3 1172rc_gettext_init() {
9a0a016d
ER
1173 if [ -z "$GETTEXT" ]; then
1174 if [ -x /bin/gettext -o -x /usr/bin/gettext ]; then
1175 GETTEXT=yes
1176 else
1177 GETTEXT=no
1178 fi
1179 fi
1180
1181 if [ -z "$TPUT" ]; then
ac1f65e1 1182 if [ -d /usr/share/terminfo ] && [ -x /usr/bin/tput -o -x /bin/tput ]; then
9a0a016d
ER
1183 TPUT=yes
1184 # check if we are on proper terminal
1185 tput longname >/dev/null 2>&1 || TPUT=no
1186 else
1187 TPUT=no
1188 fi
1189 fi
1190}
1191
439b6d80
JK
1192use_upstart () {
1193 # True when upstart-event-based boot should be used
1194 is_yes "$USE_UPSTART" && return 0
1195 is_no "$USE_UPSTART" && return 1
1196 if [ ! -x /sbin/initctl ] ; then
1197 USE_UPSTART="no"
1198 return 1
1199 fi
13b36c6c 1200 local cmdline=$(cat /proc/cmdline 2>/dev/null)
439b6d80
JK
1201 if strstr "$cmdline" "pld.no-upstart" ; then
1202 USE_UPSTART="no"
1203 return 1
1204 else
1205 USE_UPSTART="yes"
1206 return 0
1207 fi
1208}
1209
1210emit () {
1211 # emit upstart signal
1212 # only when 'upstart' boot is enabled
1213 use_upstart || return 0
1214 /sbin/initctl emit "$@"
1215}
1216
9ee04f3b
JK
1217is_upstart_task() {
1218 # Return 0 if the given service is an upstart task.
1219 grep -q '^task' "/etc/init/$1.conf"
1220}
1221is_upstart_running() {
1222 # Return 0 if the given service is running via upstart
1223 initctl status "$1" 2>/dev/null | grep -q running
1224}
1225upstart_start() {
1226 local service=$1
1227 is_upstart_running "${service}" && return 0
1228 msg_starting "${service}"
1229 if errors=$(/sbin/initctl start ${service} 2>&1) ; then
1230 ok
439b6d80 1231 return 0
9ee04f3b
JK
1232 else
1233 fail
1234 echo "$errors" >&2
1235 return 1
1236 fi
1237}
1238upstart_stop() {
1239 local service=$1
1240 if ! is_upstart_running "${service}" && ! is_upstart_task "${service}" ; then
1241 return 0
1242 fi
1243 msg_stopping "${service}"
1244 if errors=$(/sbin/initctl stop ${service}) ; then
1245 ok
1246 return 0
1247 else
1248 fail
1249 echo "$errors" >&2
1250 return 1
1251 fi
1252}
1253upstart_reload() {
1254 local service=$1
1255 if ! is_upstart_running "${service}" && ! is_upstart_task "${service}" ; then
1256 return 0
1257 fi
1258 msg_reloading "${service}"
1259 if errors=$(/sbin/initctl reload ${service}) ; then
1260 ok
1261 return 0
1262 else
1263 fail
1264 echo "$errors" >&2
1265 return 1
1266 fi
1267}
1268upstart_status() {
1269 # get service status
1270 # should be compliant with
1271 # http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
1272 local service=$1
1273 local status
1274 if is_upstart_task "${service}" ; then
1275 # we probably should have a way to handle task status
439b6d80
JK
1276 return 0
1277 fi
9ee04f3b
JK
1278 if ! status=$(/sbin/initctl status "${service}") ; then
1279 # program or service status is not known
1280 return 4
1281 fi
1282 if strstr "$status" "running" ; then
1283 # program is running or service is OK
945d7cfd 1284 echo "$status"
9ee04f3b
JK
1285 return 0
1286 else
1287 # program is not running
945d7cfd 1288 echo "$status"
9ee04f3b
JK
1289 return 3
1290 fi
1291 # TODO: other statuses
1292}
1293
1294_upstart_controlled () {
1295 # If the service is to be handled by upstart
1296 # execute the start/stop/etc. commands the upstart way
1297 if ! use_upstart ; then
1298 return 0
1299 fi
1300 local script=$1
1301 shift
1302 local command=$1
1303 shift
9ee04f3b 1304 local name=$(basename "$script")
439b6d80
JK
1305 if [ ! -f /etc/init/${name}.conf ] ; then
1306 return 0
1307 fi
9b1f5468
JK
1308 local commands
1309 local extra_commands
02271277 1310 local has_configtest
9b1f5468
JK
1311 if [ "$1" = "--except" ] ; then
1312 shift
1313 commands="$*"
1314 for cmd in $commands ; do
1315 if [ "$command" = "$cmd" ] ; then
1316 return 0
1317 fi
1318 case "$cmd" in
1319 start|stop|status|reload|restart|try-restart|force-reload)
1320 ;;
02271277
JK
1321 configtest)
1322 has_configtest=yes
1323 extra_commands="|$cmd"
1324 ;;
9b1f5468
JK
1325 *)
1326 extra_commands="|$cmd"
1327 ;;
1328 esac
1329 done
1330 elif [ -n "$*" ] ; then
1331 commands="$*"
9ee04f3b
JK
1332 local cmd
1333 local found=0
1334 # is there a better way
1335 for cmd in $commands ; do
1336 if [ "$command" = "$cmd" ] ; then
1337 found=1
1338 break;
1339 fi
1340 done
1341 if [ $found = 0 ] ; then
1342 # let the script handle it
1343 return 0
1344 fi
1345 fi
439b6d80 1346 case "$command" in
9ee04f3b
JK
1347 start)
1348 upstart_start $name
1349 exit $?
1350 ;;
1351 stop)
1352 upstart_stop $name
1353 exit $?
1354 ;;
1355 status)
1356 upstart_status $name
1357 exit $?
1358 ;;
1359 restart)
023f83d5 1360 if is_yes "$has_configtest" ; then
02271277
JK
1361 "$script" configtest || exit 1
1362 fi
9ee04f3b
JK
1363 upstart_stop $name
1364 upstart_start $name
1365 exit $?
1366 ;;
d5a0dae5
JK
1367 try-restart)
1368 if ! is_upstart_running "$name" ; then
1369 exit 0
1370 fi
023f83d5 1371 if is_yes "$has_configtest" ; then
02271277
JK
1372 "$script" configtest || exit 1
1373 fi
d5a0dae5
JK
1374 upstart_stop $name
1375 upstart_start $name
1376 exit $?
1377 ;;
9ee04f3b 1378 reload)
023f83d5 1379 if is_yes "$has_configtest" ; then
02271277
JK
1380 "$script" configtest || exit 1
1381 fi
9ee04f3b
JK
1382 if is_upstart_task "$name" ; then
1383 nls "$command not implemented for $name"
1384 exit 3
1385 else
1386 upstart_reload "$name"
1387 exit $?
1388 fi
1389 ;;
1390 force-reload)
023f83d5 1391 if is_yes "$has_configtest" ; then
02271277
JK
1392 "$script" configtest || exit 1
1393 fi
9ee04f3b
JK
1394 if is_upstart_task "$name" ; then
1395 upstart_stop "$name"
1396 upstart_start "$name"
1397 exit $?
1398 else
1399 upstart_reload "$name"
1400 exit $?
1401 fi
439b6d80
JK
1402 ;;
1403 *)
9b1f5468 1404 msg_usage "$0 {start|stop|restart|reload|force-reload|status$extra_commands}"
9ee04f3b 1405 exit 3
439b6d80
JK
1406 ;;
1407 esac
9ee04f3b 1408 return 1 # should not happen
439b6d80 1409}
9ee04f3b
JK
1410
1411# Usage:
1412# somewhere at the begining of init script:
1413# upstart_controlled
1414# - to pass implement all upstart commands via initctl
1415# start, stop, status, restart, reload and force_reload
1416# are implemented
1417# upstart_controlled command...
1418# - to pass handle only specific commands the upstart way
1419# and leave the rest to the script
1420#
945d7cfd 1421alias upstart_controlled='_upstart_controlled $0 "$@"'
439b6d80 1422
0084dcf3
ER
1423rc_gettext_init
1424rc_cache_init
f9df72e7 1425
bbb612de
AM
1426#/*
1427# * Local variables:
1428# * mode: sh
1429# * indent-tabs-mode: notnil
1430# * End:
1431# *
bbb612de 1432# */
This page took 1.543743 seconds and 4 git commands to generate.